#from typing import List
from zeep import Client
from zeep.exceptions import TransportError

from .config import TextgridConfig


class TextgridAuth:
    def __init__(self):
        self._config = TextgridConfig()

    def _connect(self) -> Client:
        """Internal helper that provides a SOAP client that is configured for
        the use with the Textgrid Auth service.

        Returns:
            Client: A SOAP client.
        """
        client = Client(self._config.auth_wsdl)
        # this is dirty hack; should be remediated
        client.service._binding_options["address"] = self._config.auth_address
        return client

    # replace ":" with " -> List | None:" when switching to python3.10
    def assigned_projects(self, sid: str):
        """Return an array of project id strings
        """
        client = self._connect()
        try:
            return client.service.tgAssignedProjects(sid)
        except TransportError:
            return None
